# Copyright (c) Huawei Technologies Co. Ltd. 2022. All rights reserved.

class CloudDBErrorCode:
    VALUE_IS_NULL = "2001"

    DATA_SIZE_IS_OVERFLOW = "2003"

    QUERY_CONDITION_IS_NULL = "2006"

    QUERY_INPUT_FIELD_NAME_IS_NULL = "2011"

    QUERY_INPUT_FIELD_NAME_DO_NOT_EXIST = "2012"

    INPUT_LIMIT_OR_OFFSET_LESS_THAN_ZERO = "2014"

    QUERY_INPUT_VALUE_IS_NULL = "2015"

    GET_ACCESS_TOKEN_FAIL = "2016"

    NETTY_COMMUNICATION_ERROR = "2017"

    AGGREGATE_QUERY_CLOUDDB_ZONE_IS_NULL = "2018"

    AGGREGATE_QUERY_FIELD_NAME_IS_NULL = "2019"

    AGGREGATE_QUERY_FIELD_TYPE_IS_NOT_NUMERIC = "2020"

    AGGREGATE_QUERY_ENTITY_DO_NOT_HAVE_FIELD = "2021"

    QUERY_INPUT_QUERY_OBJECT_IS_NULL = "2022"

    PAGINATE_QUERY_INPUT_IS_MORE_THAN_ONE = "2023"

    PAGINATE_QUERY_INPUT_IS_ONLY_SUPPORTED = "2024"

    PAGINATE_EQUAL_TO_NOT_SUPPORT_PRIMARY_KEY = "2025"

    PAGINATE_ORDER_BY_NOT_SUPPORT_TYPE = "2026"

    PAGINATE_EQUAL_TO_FIELD_IS_SAME_WITH_ORDER_BY = "2027"

    FAIL_TO_PARSE_QUERY_DATA = "2035"

    PAGINATE_NOT_SUPPORT_AGGREGATE = "2036"

    EQUAL_TO_NOT_BEFORE_ORDER_BY = "2038"

    PAGINATE_EQUAL_TO_NOT_SUPPORT_TEXT = "2039"

    ORDER_BY_ONLY_SUPPORT_ONE_DIRECTION = "2040"

    PAGINATION_ORDER_BY_HAS_DUPLICATE_FIELD = "2042"

    DO_NOT_SUPPORT_BYTEARRAY = "2043"

    DO_NOT_SUPPORT_BYTEARRAY_OR_BOOLEAN = "2044"

    ONLY_SUPPORT_TEXT_AND_STRING = "2045"

    NUMBER_IS_INVALID = "2046"

    CLASS_INVALID = "2047"

    FAIL_TO_GET_CREDENTIAL = "2048"

    RESPONSE_IS_INVALID = "2049"

    ENCRYPTED_FIELD_NOT_SUPPORT_QUERY = "2050"

    USERID_IS_INVALID = "2051"

    OBJECT_IS_INVALID = "2052"

    ORDERBY_DO_NOT_SUPPORT_TEXT_OR_BYTEARRAY = "2053"

    DATE_STRING_INVALID = "2055"

    AGCONNECT_CLOUDDB_NOT_INITIALIZE = "2056"

    DATABASE_NAME_INVALID = "2057"

    ONLY_SUPPORT_ONE_SCHEMA = "2058"

    INPUT_CONTAIN_ILLEGAL_CHARACTER = "2059"

    INPUT_PARAMETER_INVALID = "2033"

    DUPLICATE_FIELD = "2060"

    FIELD_NOT_EXIST = "2061"

    INVALID_FIELD_TYPE = "2062"

    INCREMENTAL_FIELD_ONLY_SUPPORT_NUMERIC = "2063"

    PRIMARY_KEY_REQUIRED = "2064"

    CONDITION_EXCEEDS_LIMIT = "2065"

    INVALID_CONDITION = "2066"

    PRIMARY_KEY_ENCRYPTED_FIELD_CANNOT_BE_UPDATED = "2067"

    OPERATOR_MISMATCH_CONSTRAINT = "2068"

    URL_INVALID = "3007001"

    TABLE_NAME_INVALID = "3007003"

    AUTHENTICATION_ERROR = "3007004"

    HTTPS_METHOD_INVALID = "3007005"

    ERROR_CODE_JSON_INVALID = "3007006"

    ERROR_CODE_DATA_INVALID = "3007007"

    PARAMETER_INVALID = "3007008"

    TOO_MANY_REQUESTS = "3007009"

    QUOTA_NOT_ENOUGH = "3007014"

    CHARGE_NOT_ENOUGH = "3007015"

    SYSTEM_ERROR = "3007999"

    OBJECT_TYPE_DOES_NOT_EXIST = "1070012"

    ERROR_CODE_DATA_SIZE_ZERO = "3037001"

    ERROR_CODE_DATA_NOT_CONCLUDE_PRIMARY_KEY = "3037003"

    ERROR_CODE_DATA_MISMATCH_WITH_SCHEMA = "3037004"

    ERROR_CODE_FIELD_EMPTY_WHEN_NOT_NULL = "3037005"

    ERROR_CODE_DATA_SIZE_EXCEED = "3037006"

    ERROR_CODE_DATA_NOT_IN_ARRAY = "3037007"

    ERROR_CODE_NOT_CONTAIN_QUERY_CONDITION = "3037009"

    ERROR_CODE_ENCRYPT_FIELD_CAN_NOT_BE_QUERY_CONDITION = "3037010"

    ERROR_CODE_FIELD_NAME_NOT_EXIST = "3037011"

    NOT_SUPPORT_QUERY_DATA_TYPE = "3037012"

    ERROR_CODE_FIELD_NAME_OR_VALUE_NULL = "3037013"

    ERROR_CODE_IN_QUERY_CONDITION_VALUE_NOT_ARRAY = "3037014"

    ERROR_CODE_IN_QUERY_CONDITION_VALUE_ARRAY_SIZE_ZERO = "3037015"

    ERROR_CODE_ORDER_BY_DATA_INVALID = "3037016"

    ERROR_CODE_NOT_SUPPORT_QUERY = "3037017"

    ERROR_CODE_LIMIT_DATA_INVALID = "3037018"

    ERROR_CODE_FUNCTION_IS_NOT_SUPPORT = "3037019"

    OPERATE_DATA_OVERSIZE = "3037020"

    ERROR_CODE_ORDER_GROUP_NOT_EXIST = "3037023"

    ERROR_CODE_SELECT_GROUP_FIELD_SAME = "3037024"

    ERROR_CODE_GROUP_BY_FIELD_MUST_INDEX = "3037025"

    ERROR_CODE_PAGINATION_QUERY_EQUAL_TO_NOT_SUPPORT_PRIMARY_KEY = "3037026"

    ERROR_CODE_PAGINATION_QUERY_CONDITION_NUM_ERROR = "3037027"

    ERROR_CODE_PAGINATION_QUERY_OBJECT_IS_NULL = "3037028"

    ERROR_CODE_PAGINATION_QUERY_FAILED_FOR_NO_INDEX = "3037029"

    ERROR_CODE_PAGINATION_QUERY_ORDER_BY_NOT_SUPPORT_TYPE = "3037031"

    ERROR_CODE_PAGINATION_QUERY_EQUAL_TO_SUPPORT_TYPE = "3037032"

    ERROR_CODE_PAGINATION_QUERY_ORDER_BY_DIRECTION_CONSISTENT = "3037033"

    ERROR_CODE_PAGINATION_QUERY_SEQUENCE = "3037034"

    ERROR_CODE_TRANSACTION_SEQUENCE_INCORRECT = "3037035"

    CLOUD_PAGINATION_ORDER_BY_HAS_DUPLICATE_FIELD = "3037036"

    CLOUD_SELECT_QUERY_NOT_REPEAT = "3037037"

    NOT_SUPPORT_DATA_TYPE = "3037038"

    ERROR_CODE_FIELD_NAME_NOT_EXIST_IN_UPDATE = "3037039"

    ERROR_CODE_ENCRYPTED_FIELDS_CANNOT_BE_UPDATED = "3037040"

    ERROR_CODE_SCHEMA_EXCEEDS_LIMIT_IN_WHERE_CONDITION = "3037041"

    ERROR_CODE_INVALID_INCREMENT_OR_UPDATE = "3037042"

    ERROR_CODE_FIELD_TYPE_CANNOT_INCREMENT = "3037043"

    ERROR_CODE_TOO_MANY_QUERY_CONDITION = "3037044"

    LISTENER_TOO_MANY = "3047001"

    ERROR_CODE_DATA_EXPORT_TOO_MANY = "4000009"

    AGC_CLOUD_GATEWAY_INVALID = "4007014"

    ERROR_CODE_APP_CREATION_FAILURE = "4020001"

    ERROR_CODE_INDEX_NUMBER_EXCEED = "4021001"

    ERROR_CODE_INDEX_FIELD_NUMBER_EXCEED = "4021002"

    ERROR_CODE_INDEX_NAME_INVALID = "4021003"

    ERROR_CODE_INDEX_FIELDS_REPEAT = "4021005"

    ERROR_CODE_INDEX_FIELD_NOT_EXIST_IN_SCHEMA = "4021006"

    ERROR_CODE_INDEX_FIELD_NOT_SUPPORT_SOME_TYPE = "4021008"

    ERROR_CODE_INDEX_LIST_NOT_ARRAY = "4021009"

    ERROR_CODE_SCHEMA_INDEXES_NOT_ARRAY = "4021010"

    ERROR_CODE_SCHEMA_INDEX_NOT_JSON_TYPE = "4021011"

    ERROR_CODE_SCHEMA_INDEX_SETTING_INVALID = "4021012"

    ERROR_CODE_PRIMARY_KEY_NUMBER_EXCEED = "4022001"

    ERROR_CODE_ENCRYPT_FIELD_BE_PRIMARY_KEY = "4022002"

    ERROR_CODE_PRIMARY_KEY_NOT_SUPPORT_SOME_TYPE = "4022003"

    ERROR_CODE_PRIMARY_KEY_SHALL_NOT_NULL = "4022004"

    ERROR_CODE_PRIMARY_KEY_SHALL_NOT_SET_DEFAULT_VALUE = "4022005"

    NOT_NULL_FIELD_NOT_SUPPORT_SOME_TYPE = "4023001"

    ERROR_CODE_ENCRYPT_FIELD_NOT_SET_NOT_NULL = "4023002"

    ERROR_CODE_SCHEMA_FIELD_DEFAULT_VALUE_INVALID = "4024001"

    SCHEMA_DEFAULT_VALUE_NOT_SUPPORT = "4024002"

    ERROR_CODE_SCHEMA_DEFAULT_VALUE_EMPTY = "4024003"

    ERROR_CODE_DEFAULT_VALUE_INVALID = "4024004"

    ERROR_CODE_ENCRYPT_FIELD_SET_DEFAULT_VALUE = "4024005"

    ERROR_CODE_NOT_SET_DEFAULT_VALUE_AS_NOT_NULL_TRUE = "4024006"

    ERROR_CODE_RIGHT_NOT_ARRAY_TYPE = "4026001"

    ERROR_CODE_RIGHT_EMPTY = "4026002"

    ERROR_CODE_RIGHT_MEMBER_NOT_JSON_TYPE = "4026003"

    ERROR_CODE_RIGHT_MISMATCH_WITH_ROLE = "4026004"

    ERROR_CODE_RIGHT_NOT_SETTING = "4026005"

    ERROR_CODE_RIGHT_SETTING_FOR_NOT_EXIST_SCHEMA = "4026006"

    ERROR_CODE_RIGHT_NOT_SUPPORT = "4026007"

    ERROR_CODE_SCHEMA_VERSION_INVALID = "4027003"

    ERROR_CODE_SCHEMA_FIELD_NUMBER_EXCEED = "4027005"

    ERROR_CODE_STRING_TYPE_NUMBER_EXCEED = "4027006"

    ERROR_CODE_SCHEMAS_JSON_EMPTY = "4027008"

    ERROR_CODE_SCHEMAS_MEMBER_NOT_JSON_TYPE = "4027009"

    ERROR_CODE_SCHEMA_FIELDS_NOT_ARRAY = "4027010"

    ERROR_CODE_SCHEMA_FIELDS_NOT_EXIST = "4027011"

    ERROR_CODE_SCHEMA_FIELDS_NOT_JSON_TYPE = "4027012"

    ERROR_CODE_SCHEMA_FIELD_ATTRIBUTES_EMPTY = "4027013"

    ERROR_CODE_SCHEMA_FIELD_NAME_INVALID = "4027014"

    SCHEMA_FIELD_ATTRIBUTES_NOT_BOOLEAN = "4027015"

    ERROR_CODE_SCHEMA_NO_PRIMARY_KEY = "4027017"

    ERROR_CODE_SCHEMA_INVALID = "4027018"

    ERROR_CODE_SCHEMA_PACKAGE_NAME_INVALID = "4027019"

    ERROR_CODE_SCHEMA_PACKAGE_EXPORT_ERROR = "4027020"

    WRITE_DATA_SIZE_EXCEED_PER_SECOND = "4027023"

    ENCRYPT_FIELD_PERMISSION_INVALID = "4027024"

    ENCRYPT_FIELD_NUM_EXCEED = "4027025"

    ENCRYPT_FIELD_TYPE_INVALID = "4027026"

    ERROR_CODE_EXPORT_DATA_PARA_INVALID = "4030001"

    ERROR_CODE_EXPORT_ENCRYPT_SCHEMA = "4030002"

    ERROR_CODE_IMPORT_ENCRYPT_SCHEMA = "4030003"

    ERROR_CODE_DATA_SIZE_BIGGER_THAN_ONE = "4037001"

    ERROR_CODE_PROCESS_ID_INVALID = "4038001"

    ERROR_CODE_SCHEMA_NUMBER_EXCEED = "2001005"

    PRIMARY_KEY_NOT_SUPPORT_CHANGE = "2001006"

    ERROR_CODE_PERMISSION_DENIED = "2001015"

    ERROR_QUERY_DATA_SIZE_TOO_LARGE = "2001017"

    ERROR_QUERY_DATA_COUNT_TOO_LARGE = "2001018"

    ERROR_CODE_DATA_UPSERT_TOO_LARGE = "2001020"

    UPDATE_FIELDS_COUNT_EXCEED_LIMIT = "2001035"

    OPERATORS_COUNT_IN_EXPRESSION_EXCEED_LIMIT = "2001036"

    SCHEMA_ALREADY_CHANGED = "2002005"

    SCHEMA_NOT_EXISTING = "2002007"

    ERROR_CODE_SCHEMA_FIELD_NAME_SAME = "2002012"

    ERROR_CODE_INDEX_NAME_REPEAT = "2002018"

    ERROR_CODE_PARAM_INVALID = "2002000"

    ERROR_CODE_NOT_NULL_FIELD_CANNOT_BE_NULL = "2002036"

    ERROR_CODE_DATABASE_NOT_EXIST = "2002037"

    PRIMARY_KEY_CANNOT_BE_UPDATED = "2002041"

    ERROR_CODE_OBJECT_NOT_EXIST = "2002043"

    ERROR_CODE_PRIMARY_KEY_DUPLICATE = "2002044"

    ERROR_CODE_FIELD_TYPE_NOT_SUPPORT_INCREMENT = "2002045"

    ERROR_TRANSACTION_FAILED_DATA_CHANGED = "2003049"

    ERROR_CODE_VALUE_OUT_OF_RANGE = "2003053"

    ERROR_CODE_IMPORT_DATA_INDEX_FIELD_VALUE_LENGTH_EXCEED = "2003094"

    ERROR_CODE_VIOLATES_UNIQUE_CONSTRAINT = "2003097"
